import QtQuick 2.1
import qb.components 1.0
import qb.base 1.0;

App {
	id: root
	// These are the URL's for the QML resources from which our widgets will be instantiated.
	// By making them a URL type property they will automatically be converted to full paths,
	// preventing problems when passing them around to code that comes from a different path.
	property url trayUrl : "DomoticzTray.qml";
	property url thumbnailIcon: "qrc:/tsc/DomoticzSystrayIconold.png"
	property url domoticzScreenUrl : "DomoticzScreen.qml"
	property url tileUrl : "DomoticzTray.qml"

	property string timeStr
	property string dateStr
	
	//Edit these settings:
	property string username: "=" //see https://www.base64encode.net/
	property string password: "=" //see https://www.base64encode.net/
	property string hostName: "0.0.0.0"
	property string portNum: "8080"
	//Stop editing here!

	//Edit these setting:
	property string switch1idx: "88" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch1StatusIcon
	property string switch1Name
	
	//Edit these setting:
	property string switch2idx: "76" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch2StatusIcon
	property string switch2Name
	
	//Edit these setting:
	property string switch3idx: "87" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch3StatusIcon
	property string switch3Name
	
	//Edit these setting:
	property string switch4idx: "91" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch4StatusIcon
	property string switch4Name
	
	//Edit these setting:
	property string switch5idx: "90" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch5StatusIcon
	property string switch5Name
	
	//Edit these setting:
	property string switch6idx: "89" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch6StatusIcon
	property string switch6Name

	//Edit these setting:
	property string switch7idx: "62" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch7StatusIcon
	property string switch7Name
	
	//Edit these setting:
	property string switch8idx: "98" //put IDX of switch/wall plug here
	//Stop editing here!
	property string switch8StatusIcon
	property string switch8Name

	
	function init() {
		registry.registerWidget("systrayIcon", trayUrl, this, "domoticzTray");
		registry.registerWidget("screen", domoticzScreenUrl, this);
	}

	function readDeviceStatus(idx) {
		var xmlhttp = new XMLHttpRequest();
		var i;
		var j;
		var tmpDeviceStatus;
		xmlhttp.onreadystatechange=function() {
			if (xmlhttp.readyState == 4) {
				if (xmlhttp.status == 200) {
					var res = xmlhttp.responseText;
										
					i = res.indexOf('"Name"');
					j = res.indexOf('"', i+10);
					if (idx == switch1idx) {
						switch1Name = res.substring(i+10 , j);
					} else if (idx == switch2idx) {
						switch2Name = res.substring(i+10 , j);
					} else if (idx == switch3idx) {
						switch3Name = res.substring(i+10 , j);
					} else if (idx == switch4idx) {
						switch4Name = res.substring(i+10 , j);
					} else if (idx == switch5idx) {
						switch5Name = res.substring(i+10 , j);
					} else if (idx == switch6idx) {
						switch6Name = res.substring(i+10 , j);
					} else if (idx == switch7idx) {
						switch7Name = res.substring(i+10 , j);
					} else if (idx == switch8idx) {
						switch8Name = res.substring(i+10 , j);
					}
					
					i = res.indexOf('"Status"', j);
					j = res.indexOf('"', i+12);
					tmpDeviceStatus = res.substring(i+12, j);
					if (idx == switch1idx) {
						if (tmpDeviceStatus == "On") {
							switch1StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch1StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					} else if (idx == switch2idx) {
						if (tmpDeviceStatus == "On") {
							switch2StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch2StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					} else if (idx == switch3idx) {
						if (tmpDeviceStatus == "On") {
							switch3StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch3StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					} else if (idx == switch4idx) {
						if (tmpDeviceStatus == "On") {
							switch4StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch4StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					} else if (idx == switch5idx) {
						if (tmpDeviceStatus == "On") {
							switch5StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch5StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					} else if (idx == switch6idx) {
						if (tmpDeviceStatus == "On") {
							switch6StatusIcon = "qrc:/tsc/button_on.png";
						} else {
							switch6StatusIcon = "qrc:/tsc/button_off.png";
						}
					} else if (idx == switch7idx) {
						if (tmpDeviceStatus == "On") {
							switch7StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch7StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					} else if (idx == switch8idx) {
						if (tmpDeviceStatus == "On") {
							switch8StatusIcon = "qrc:/tsc/HomeSunny.png";
						} else {
							switch8StatusIcon = "qrc:/tsc/DimSunny.png";
						}
					}
				}
			}
		}
		xmlhttp.open("GET", "http://"+hostName+":"+portNum+"/json.htm?username="+username+"&password="+password+"&type=devices&rid="+idx, true);
		xmlhttp.send();
	}
	
	
	function updateDomoticzLight1() {
		readDeviceStatus(switch1idx);
	}
	function updateDomoticzLight2() {
		readDeviceStatus(switch2idx);
	}
	function updateDomoticzLight3() {
		readDeviceStatus(switch3idx);
	}
	function updateDomoticzLight4() {
		readDeviceStatus(switch4idx);
	}
	function updateDomoticzLight5() {
		readDeviceStatus(switch5idx);
	}
	function updateDomoticzLight6() {
		readDeviceStatus(switch6idx);
	}
	function updateDomoticzLight7() {
		readDeviceStatus(switch7idx);
	}
	function updateDomoticzLight8() {
		readDeviceStatus(switch8idx);
	}
	
	Timer {
		id: datetimeTimer
		interval: 2000
		triggeredOnStart: true
		running: true
		repeat: true
		onTriggered: {
			updateDomoticzLight1();
			updateDomoticzLight2();
			updateDomoticzLight3();
			updateDomoticzLight4();
			updateDomoticzLight5();
			updateDomoticzLight6();
			updateDomoticzLight7();
			updateDomoticzLight8();
		}
	}
}
